#!/usr/bin/perl -w
use strict;
use Status;
use Constants;
use CGI;
use DBI;

# CGI stuff
my $cgi = new CGI;

# Constants of the whole program
my $dbconsts = Constants->new();
my %consts   = $dbconsts->constants();

# Connect to DB
my $dsn = "DBI:mysql:host=localhost;database=${consts{database}}";
my $db = DBI->connect( $dsn, $consts{user}, $consts{password} )
  or die DBI->errstr;

# Data from webgui.cgi of user input
print $cgi->header;
my @params   = $cgi->param;
my $router = $cgi->param( $params[0] );
my $startDate =
    $cgi->param( $params[3] ) . "-"
  . $cgi->param( $params[2] ) . "-"
  . $cgi->param( $params[1] );
my $finalDate =
    $cgi->param( $params[6] ) . "-"
  . $cgi->param( $params[5] ) . "-"
  . $cgi->param( $params[4] );
my $interval   = $cgi->param( $params[7] );
my $routerName = $router;                   # For printing issues

if ( $router =~ /%/ ) {
    $routerName = "all";
}

print "<a href=\"webgui.cgi\"><< Back</a></br></br>\n";

# Query for report
my $status = Status->new( $consts{database}, $db, $consts{statustable} );
my @selectArray = ( "date", "time", "status", "router", "interface" );
my $selectArray = join( ",", @selectArray );
my $selectQuery = "
SELECT $selectArray FROM "
  . $status->database() . "."
  . $status->table()
  . " WHERE router LIKE '%$router%' AND date BETWEEN '"
  . $startDate
  . "' AND '"
  . $finalDate . "'";
my @statusRows = $status->fetchRows($selectQuery)
  or die "Cannot fetch rows of the mysql query.<br />\n";
my $totalIncidents =
  $status->runDataGather( $consts{plotinput}, $routerName, $interval,
    $consts{plotter}, $consts{plotoutput}, @statusRows )
  or die "Cannot gather data for plotting.<br />\n";

if ($totalIncidents) {
    print "Total Incidents: $totalIncidents<br />\n";
    print "<img src=\"/trapd/images/status.png\" />";
}
else {
    print "<br />No records found to show.<br />\n";
}
$status->printRows( scalar @selectArray, \@statusRows, \@selectArray );

exit;
