#!/usr/bin/perl -w
use strict;
use Status;
use Constants;
use DBI;

# Path to mysqladmin
my $mysqladmin = "/usr/bin/mysqladmin";

# File to be opened
my $filename = $ARGV[0];

# Constants of DB
my $dbconsts = Constants->new();
my %consts   = $dbconsts->constants();

# Try to create the DB if not exists and connect to it
eval {
qx($mysqladmin create $consts{database} -u $consts{user} -p$consts{password_alternate});
};
my $dsn = "DBI:mysql:host=localhost;database=${consts{database}}";
my $db = DBI->connect( $dsn, $consts{user}, $consts{password} )
  or die DBI->errstr;

# Create the status table
my $tblcreate = "
CREATE TABLE IF NOT EXISTS $consts{statustable}(
        id      INT NOT NULL auto_increment,
        date    DATE NOT NULL,
        time    TIME NOT NULL,
	router	VARCHAR(50) NOT NULL,
        ip      INT UNSIGNED NOT NULL,
	interface VARCHAR(50) NOT NULL,
        status  VARCHAR(4) NOT NULL,
CONSTRAINT ID_PK PRIMARY KEY(id))";
my $cvar = $db->prepare($tblcreate);
$cvar->execute()
  or die DBI->errstr;

my $status = Status->new( $consts{database}, $db, $consts{statustable} );
$status->runTrapGetter($filename) or die("Cannot run the status\n");

# End
$cvar->finish();
$db->disconnect();
exit;
